> ## Documentation Index
> Fetch the complete documentation index at: https://kb.talostrading.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Timeframes of asset metric constituents

> Returns timeframes of asset metric constituents. \
Results are sorted by tuple (`start_time`, `constituent_name`), where constituent depends on a target metric. 
E.g., the `volume_trusted_spot_usd_1d` metric constituents are exchanges, 
i.e. the output will be sorted by (`start_time`, `exchange`).




## OpenAPI

````yaml /coinmetrics/openapi/coinmetrics.yaml get /constituent-timeframes/asset-metrics
openapi: 3.0.2
info:
  title: Coin Metrics API v4
  description: >-
    [Coin Metrics Homepage](https://coinmetrics.io/)<br/> [API Backward
    Compatibility
    Policy](https://docs.coinmetrics.io/access-our-data/api#backward-compatibility)<br/>
    [Python API
    Client](https://coinmetrics.github.io/api-client-python/site/index.html)<br/><br/>

    HTTP API root endpoint URL is `https://api.coinmetrics.io/v4`. Coin
    Metrics&apos; paid product.<br/> WebSocket API root endpoint is
    `wss://api.coinmetrics.io/v4`. Coin Metrics&apos; paid product.<br/><br/>
    The Community HTTP API root endpoint URL is
    `https://community-api.coinmetrics.io/v4`. API key is not required when
    accessing community endpoints. Available to the community under the
    [Creative Commons](https://creativecommons.org/licenses/by-nc/4.0/) license.

    # Authentication

    <!-- ReDoc-Inject: <security-definitions> -->

    # Response headers

    Note that Coin Metrics API responses have a `CF-RAY` HTTP header e.g.
    `88a6ec1d2f930774-IAD` which can be used for diagnostic purposes. When
    raising Support requests, please ensure to provide the value of this
    header. 
  termsOfService: https://coinmetrics.io/api/terms
  contact:
    name: Coin Metrics Support
    url: https://coinmetrics.io/support/
    email: support@coinmetrics.io
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.html
  version: 4.0.0
servers:
  - url: https://api.coinmetrics.io/v4
  - url: wss://api.coinmetrics.io/v4
  - url: https://community-api.coinmetrics.io/v4
security: []
tags:
  - name: Rate limits
    description: >-
      To ensure the quality of Coin Metrics services, API is subject to rate
      limiting.<br/> <table> <tr><th>Rate Limit Plan</th><th>REST API: Requests
      per Second (sliding window)</th><th>REST API: Download Speed</th><th>REST
      API: Max Parallel Requests</th><th>WebSocket API: Max Parallel
      Connections</th></tr> <tr><td>Community</td><td>10 requests per 6 seconds
      per IP address</td><td>Reduced speed</td><td>10</td><td>N/A</td></tr>
      <tr><td>Trial</td><td>10 requests per 6 seconds per API key</td><td>Max
      speed</td><td>10</td><td>200</td></tr> <tr><td>Default (PRO)</td><td>6000
      requests per 20 seconds per API key</td><td>Standard
      speed</td><td>10</td><td>200</td></tr> <tr><td>Download (PRO)</td><td>6000
      requests per 20 seconds per API key</td><td>Max
      speed</td><td>10</td><td>200</td></tr> </table> <br/> All PRO keys by
      default get the "default" rate limits. To download historical data at max
      speed, you need to switch to the "download" plan. <br/> <br/> The paid and
      community versions of the API have a limit of 10 parallel REST API
      requests. After this limit is reached, further parallel requests will be
      queued, so performance will be slower.<br/> <br/> If you reach the
      request-per-second limit, API starts to return `429 Too Many Requests`
      HTTP response status.<br/> API also provides `X-RateLimit-*` response
      headers formatted according to
      https://tools.ietf.org/html/draft-polli-ratelimit-headers-03.<br/>
      Additionally, the API provides the `X-RateLimit-Plan` header which
      indicates the current rate limiting plan. This header may have values:
      `default`, `trial`, `download`, or `community`.
    x-cm-gitbook:
      foldIntoInfo: true
  - name: Reference Data
    description: Metadata information of entities supported by Coin Metrics.
    x-cm-gitbook:
      tag: Meta Data
      icon: book
  - name: Catalog
    x-displayName: Catalog (deprecated)
    description: >-
      Catalog of available for your `api_key` data.<br/> Use the [Full
      catalog](#tag/Full-catalog) endpoints for the full list of supported by
      Coin Metrics data. <br/>DEPRECATED: See
      https://coinmetrics.io/important-changes-to-coin-metrics-api-catalog-endpoints/.
    x-cm-gitbook:
      remove: true
  - name: Catalog v2
    description: >-
      Catalog of available for your `api_key` data.<br/> Use the [Full catalog
      V2](#tag/Full-catalog-v2) endpoints for the full list of supported by Coin
      Metrics data.
    x-cm-gitbook:
      icon: list-check
  - name: Full catalog
    x-displayName: Full catalog (deprecated)
    description: >-
      The Full catalog returns the full range of data that is supported by Coin
      Metrics across all our products.<br/> If you are a client looking to
      understand the data that is available for your API key and data license,
      please use the [Catalog](#tag/Catalog) endpoint. <br/>DEPRECATED: See
      https://coinmetrics.io/important-changes-to-coin-metrics-api-catalog-endpoints/.
    x-cm-gitbook:
      remove: true
  - name: Full catalog v2
    description: >-
      The Full catalog returns the full range of data that is supported by Coin
      Metrics across all our products.<br/> If you are a client looking to
      understand the data that is available for your API key and data license,
      please use the [Catalog](#tag/Catalog-v2) endpoint.
    x-cm-gitbook:
      tag: Catalog v2
      icon: layer-group
  - name: Timeseries
    description: >-
      Endpoints for fetching metrics, market data, indexes and other time series
      data.
    x-cm-gitbook:
      icon: chart-line
      renameOperationsTo: Timeseries REST
  - name: Timeseries stream
    description: >-
      WebSocket endpoints for getting a real-time stream of metrics, market
      data, indexes and other time series data.
    x-cm-gitbook:
      tag: Timeseries
      icon: wifi
  - name: Taxonomy
    description: Taxonomy endpoints
    x-cm-gitbook:
      icon: sitemap
  - name: Taxonomy Metadata
    description: Taxonomy Metadata endpoints
    x-cm-gitbook:
      tag: Taxonomy
      icon: tags
  - name: Profile
    description: Profile endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: id-card
  - name: List of blockchain entities v2
    description: Endpoints for fetching lists of blockchain entities.
    x-cm-gitbook:
      tag: ATLAS
      icon: list
  - name: Full blockchain entities v2
    description: Endpoints for fetching full blockchain entities.
    x-cm-gitbook:
      tag: List of blockchain entities v2
      icon: database
  - name: Jobs
    description: Jobs API endpoints
    x-cm-gitbook:
      tag: ATLAS
      icon: briefcase
  - name: Blockchain Explorer Job
    description: Endpoints for creating async jobs for blockchain entities.
    x-cm-gitbook:
      tag: ATLAS
      icon: clock
  - name: Blockchain Explorer Job Results
    description: Schema definitions of results of Blockchain Explorer Job endpoints.
    x-cm-gitbook:
      foldInto: Blockchain Explorer Job
  - name: Chain Monitor tools
    description: Endpoints for working with chain monitor data.
    x-cm-gitbook:
      tag: ATLAS
      icon: wrench
  - name: Security Master
    description: Security Master endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: shield
  - name: Constituent Snapshots
    description: Endpoints for getting the snapshots of various constituents
    x-cm-gitbook:
      tag: Meta Data
      icon: camera
  - name: Constituent Timeframes
    description: Endpoints for getting the timeframes of various constituents
    x-cm-gitbook:
      tag: Meta Data
      icon: calendar
  - name: Blockchain Metadata
    description: Blockchain metadata endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: database
  - name: Meta Data
    x-cm-gitbook:
      icon: database
  - name: ATLAS
    x-cm-gitbook:
      icon: map
  - name: Timeseries REST
    x-cm-gitbook:
      tag: Timeseries
      icon: table
paths:
  /constituent-timeframes/asset-metrics:
    servers:
      - url: https://api.coinmetrics.io/v4
      - url: https://community-api.coinmetrics.io/v4
    get:
      tags:
        - Constituent Timeframes
      summary: Timeframes of asset metric constituents
      description: >
        Returns timeframes of asset metric constituents. \

        Results are sorted by tuple (`start_time`, `constituent_name`), where
        constituent depends on a target metric. 

        E.g., the `volume_trusted_spot_usd_1d` metric constituents are
        exchanges, 

        i.e. the output will be sorted by (`start_time`, `exchange`).
      operationId: getConstituentTimeframesAssetMetrics
      parameters:
        - $ref: '#/components/parameters/ConstituentsMetricName'
        - $ref: '#/components/parameters/ConstituentId'
        - $ref: '#/components/parameters/ConstituentsStartTime'
        - $ref: '#/components/parameters/ConstituentsEndTime'
        - $ref: '#/components/parameters/NextPageToken'
        - $ref: '#/components/parameters/PageSize'
        - $ref: '#/components/parameters/PagingFrom'
        - $ref: '#/components/parameters/Format'
        - $ref: '#/components/parameters/Pretty'
      responses:
        '200':
          $ref: '#/components/responses/AssetMetricsConstituentTimeframes'
        '400':
          $ref: '#/components/responses/MetricNotFound'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '403':
          $ref: '#/components/responses/Forbidden'
        '414':
          $ref: '#/components/responses/UriTooLong'
      security:
        - api_key: []
      x-codeSamples:
        - lang: Shell
          label: Shell
          source: >
            # Gets timeframes of asset metric constituents

            curl --compressed
            "https://api.coinmetrics.io/v4/constituent-timeframes/asset-metrics?metric=volume_trusted_spot_usd_1d&api_key=<your_key>"
        - lang: Python
          label: Python
          source: >
            # Gets timeframes of asset metric constituents

            import requests

            response =
            requests.get('https://api.coinmetrics.io/v4/constituent-timeframes/asset-metrics?metric=volume_trusted_spot_usd_1d&api_key=<your_key>').json()

            print(response)
        - lang: Python
          label: Python Client
          source: >
            # Gets timeframes of asset metric constituents

            from coinmetrics.api_client import CoinMetricsClient

            client = CoinMetricsClient(<your_key>)


            response =
            client.get_timeframes_of_asset_metric_constituents(metric="volume_trusted_spot_usd_1d").to_list()

            print(response)
components:
  parameters:
    ConstituentsMetricName:
      description: Target metric name.
      name: metric
      in: query
      required: true
      schema:
        type: string
    ConstituentId:
      description: >
        Comma separated list of constituents. By default all constituents are
        returned.

        Different asset metrics may have different constituents.

        For example, constituents for `volume_trusted_spot_usd_1d` are
        exchanges.
      example: null
      name: constituents
      in: query
      required: false
      schema:
        type: array
        items:
          type: string
      explode: false
    ConstituentsStartTime:
      description: >
        Start of the time interval, inclusive. \

        Multiple formats of ISO 8601 are supported: `2006-01-20T00:00:00Z`,
        `2006-01-20T00:00:00.000Z`, `2006-01-20T00:00:00.123456Z`,
        `2006-01-20T00:00:00.123456789Z`, `2006-01-20`, `20060120`. \

        Mutually exclusive with `at_time`.
      name: start_time
      in: query
      schema:
        type: string
    ConstituentsEndTime:
      description: >
        End of the time interval, inclusive. \

        Multiple formats of ISO 8601 are supported: `2006-01-20T00:00:00Z`,
        `2006-01-20T00:00:00.000Z`, `2006-01-20T00:00:00.123456Z`,
        `2006-01-20T00:00:00.123456789Z`, `2006-01-20`, `20060120`. \

        Mutually exclusive with `at_time`.
      name: end_time
      in: query
      schema:
        type: string
    NextPageToken:
      description: >-
        Token for receiving the results from the next page of a query.<br/>
        Should not be used directly. To iterate through pages just use
        `next_page_url` response field.
      in: query
      name: next_page_token
      schema:
        type: string
    PageSize:
      description: >-
        Number of items per single page of results.<br/> The value of this
        parameter is ignored if the endpoint supports the `format` parameter and
        its value is set to `json_stream`.
      in: query
      name: page_size
      schema:
        default: 100
        type: integer
        format: int32
        minimum: 1
        maximum: 10000
    PagingFrom:
      description: >-
        Where does the first page start, at the start of the interval or at the
        end.<br/> The value of this parameter is ignored if the endpoint
        supports the `format` parameter and its value is set to `json_stream`.
      in: query
      name: paging_from
      schema:
        default: end
        enum:
          - start
          - end
        type: string
        format: PagingFrom
    Format:
      description: Format of the response.
      in: query
      name: format
      schema:
        enum:
          - json
          - csv
        type: string
        default: json
    Pretty:
      description: Human-readable formatting of JSON responses.
      in: query
      name: pretty
      schema:
        type: boolean
        default: false
  responses:
    AssetMetricsConstituentTimeframes:
      description: List of timeframes.
      content:
        application/json:
          example:
            data:
              - exchange: gemini
                start_time: '2023-10-12T00:00:00.000000000Z'
                end_time: null
              - exchange: kraken
                start_time: '2023-10-12T00:00:00.000000000Z'
                end_time: null
              - exchange: binance
                start_time: '2023-04-01T00:00:00.000000000Z'
                end_time: '2023-10-12T00:00:00.000000000Z'
              - exchange: binance.us
                start_time: '2023-04-01T00:00:00.000000000Z'
                end_time: '2023-10-12T00:00:00.000000000Z'
              - exchange: bitstamp
                start_time: '2023-04-01T00:00:00.000000000Z'
                end_time: '2023-10-12T00:00:00.000000000Z'
            next_page_token: 0.MjAxNy0wNS0yMlQwMDowMDowMFo
            next_page_url: >-
              https://api.coinmetrics.io/v4/constituent-timeframes/asset-metrics?metric=volume_trusted_spot_usd_1d&pretty=true&page_size=5&api_key=<your_key>
          schema:
            $ref: '#/components/schemas/ConstituentTimeframesAssetMetricsResponse'
        text/csv:
          example: >-
            exchange,start_time,end_time

            gemini,2023-10-12T00:00:00.000000000Z,null

            kraken,2023-10-12T00:00:00.000000000Z,null

            binance,2023-04-01T00:00:00.000000000Z,2023-10-12T00:00:00.000000000Z

            binance.us,2023-04-01T00:00:00.000000000Z,2023-10-12T00:00:00.000000000Z

            bitstamp,2023-04-01T00:00:00.000000000Z,2023-10-12T00:00:00.000000000Z
          schema:
            $ref: '#/components/schemas/ConstituentTimeframesAssetMetricsResponse'
    MetricNotFound:
      content:
        application/json:
          example:
            error:
              type: bad_parameter
              message: Bad parameter 'metrics'. Value 'asdgwav' is not supported.
          schema:
            $ref: '#/components/schemas/ErrorResponse'
      description: Metric not found.
    Unauthorized:
      description: Requested resource requires authorization.
      content:
        application/json:
          examples:
            unauthorized:
              summary: Unauthorized error response.
              value:
                error:
                  type: unauthorized
                  message: Requested resource requires authorization.
            wrong_credentials:
              summary: Wrong credentials error response.
              value:
                error:
                  type: wrong_credentials
                  message: Supplied credentials are not valid.
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    Forbidden:
      content:
        application/json:
          example:
            error:
              type: forbidden
              message: >-
                Requested metric 'SplyBMXNtv' with frequency '1d' for asset
                'btc' is not available with supplied credentials.
          schema:
            $ref: '#/components/schemas/ErrorResponse'
      description: Requested resource is not available with supplied credentials.
    UriTooLong:
      description: Provided URI is too long. It must not be greater than 10000 symbols.
  schemas:
    ConstituentTimeframesAssetMetricsResponse:
      description: Timeframes of asset metric constituents response.
      type: object
      properties:
        data:
          type: array
          items:
            type: object
            properties:
              start_time:
                $ref: '#/components/schemas/Time'
              end_time:
                $ref: '#/components/schemas/Time'
            required:
              - start_time
            additionalProperties:
              nullable: true
              type: string
        next_page_token:
          $ref: '#/components/schemas/NextPageToken'
        next_page_url:
          $ref: '#/components/schemas/NextPageUrl'
      required:
        - data
    ErrorResponse:
      properties:
        error:
          $ref: '#/components/schemas/ErrorObject'
      required:
        - error
      type: object
    Time:
      description: >-
        The time in ISO 8601 date-time format. Always with nanoseconds
        precision.
      type: string
      format: date-time
    NextPageToken:
      description: Token of the next page results for a given request.
      type: string
    NextPageUrl:
      description: URL of the next page results for a given request.
      type: string
    ErrorObject:
      properties:
        type:
          description: Error type string. Can be used for error identification.
          type: string
        message:
          description: >-
            Human-friendly error description. Can be amended without prior
            notification. Do not use for error identification in your code.
          type: string
      required:
        - type
        - description
      type: object
  securitySchemes:
    api_key:
      description: Coin Metrics API key can be specified as `?api_key=` query parameter.
      in: query
      name: api_key
      type: apiKey

````